Index: common/cmd_config.c
===================================================================
RCS file: common/cmd_config.c
diff -N common/cmd_config.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ common/cmd_config.c	3 Feb 2005 10:35:41 -0000	1.1
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2001 William L. Pitts
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms are freely
+ * permitted provided that the above copyright notice and this
+ * paragraph and the following disclaimer are duplicated in all
+ * such forms.
+ *
+ * This software is provided "AS IS" and without any express or
+ * implied warranties, including, without limitation, the implied
+ * warranties of merchantability and fitness for a particular
+ * purpose.
+ */
+
+#include <common.h>
+#include <command.h>
+
+
+#ifdef CONFIG_PEPPERCON
+
+static int do_config(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+	printf("Please wait...\n");
+	gd->bd->bi_config_mode = 1;
+	gd->bd->bi_debug_mode = 0;
+	gd->serial_debug = 0;
+	return (run_command(getenv("bootcmd"), flag, 0) < 0 ? 1 : 0);
+}
+
+U_BOOT_CMD(
+        config, 1,              1,      do_config,
+        "config  - start configuration tool after bootup\n",
+	""
+);
+
+#endif	/* CONFIG_PEPPERCON */
Index: common/cmd_defaults.c
===================================================================
RCS file: common/cmd_defaults.c
diff -N common/cmd_defaults.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ common/cmd_defaults.c	24 May 2005 14:01:50 -0000	1.2
@@ -0,0 +1,38 @@
+/*
+ * Copyright (c) 2004 Peppercon AG
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms are freely
+ * permitted provided that the above copyright notice and this
+ * paragraph and the following disclaimer are duplicated in all
+ * such forms.
+ *
+ * This software is provided "AS IS" and without any express or
+ * implied warranties, including, without limitation, the implied
+ * warranties of merchantability and fitness for a particular
+ * purpose.
+ */
+
+#include <common.h>
+#include <command.h>
+
+
+#ifdef CONFIG_PEPPERCON
+
+static int do_defaults(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+	printf("Please wait...\n");
+	gd->bd->bi_def_jumper_set = PP_DEFAULTS_COMMAND;
+	gd->bd->bi_debug_mode = 0;
+	gd->serial_debug = 0;
+	return (run_command(getenv("bootcmd"), flag, 0) < 0 ? 1 : 0);
+}
+
+U_BOOT_CMD(
+	defaults, 1,              1,      do_defaults,
+        "defaults- set the device settings to their factory defaults\n",
+	""
+);
+
+#endif	/* CONFIG_PEPPERCON */
Index: common/cmd_develmode.c
===================================================================
RCS file: common/cmd_develmode.c
diff -N common/cmd_develmode.c
--- /dev/null	1 Jan 1970 00:00:00 -0000
+++ common/cmd_develmode.c	24 May 2005 14:01:50 -0000	1.2
@@ -0,0 +1,35 @@
+/*
+ * Copyright (c) 2004 Peppercon AG
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms are freely
+ * permitted provided that the above copyright notice and this
+ * paragraph and the following disclaimer are duplicated in all
+ * such forms.
+ *
+ * This software is provided "AS IS" and without any express or
+ * implied warranties, including, without limitation, the implied
+ * warranties of merchantability and fitness for a particular
+ * purpose.
+ */
+
+#include <common.h>
+#include <command.h>
+
+
+#ifdef CONFIG_PEPPERCON
+
+static int do_devel_mode(cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
+{
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+	gd->devel_mode = 1;
+	return 0;
+}
+
+U_BOOT_CMD(
+        erla, 1,              1,      do_devel_mode,
+        "",
+	""
+);
+
+#endif	/* CONFIG_PEPPERCON */
Index: common/cmd_net.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/common/cmd_net.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- common/cmd_net.c	3 Feb 2005 09:43:15 -0000	1.1.333.1
+++ common/cmd_net.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -40,11 +40,13 @@
 	return netboot_common (BOOTP, cmdtp, argc, argv);
 }
 
+#ifdef CONFIG_BOOTP 
 U_BOOT_CMD(
 	bootp,	3,	1,	do_bootp,
 	"bootp   - boot image via network using BootP/TFTP protocol\n",
 	"[loadAddress] [bootfilename]\n"
 );
+#endif
 
 int do_tftpb (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
 {
@@ -62,11 +64,13 @@
 	return netboot_common (RARP, cmdtp, argc, argv);
 }
 
+#if CONFIG_RARP
 U_BOOT_CMD(
 	rarpboot,	3,	1,	do_rarpb,
 	"rarpboot- boot image via network using RARP/TFTP protocol\n",
 	"[loadAddress] [bootfilename]\n"
 );
+#endif
 
 #if (CONFIG_COMMANDS & CFG_CMD_DHCP)
 int do_dhcp (cmd_tbl_t *cmdtp, int flag, int argc, char *argv[])
Index: common/command.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/common/command.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- common/command.c	3 Feb 2005 09:43:15 -0000	1.1.333.1
+++ common/command.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -80,7 +80,8 @@
  */
 int do_help (cmd_tbl_t * cmdtp, int flag, int argc, char *argv[])
 {
-	int i;
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+	 int i;
 	int rcode = 0;
 
 	if (argc == 1) {	/*show list of commands */
@@ -122,7 +123,11 @@
 				return 1;
 			if (usage == NULL)
 				continue;
-			puts (usage);
+#ifdef CONFIG_PEPPERCON			
+			if (gd->devel_mode || cmd_array[i]->user_allowed)
+#endif
+			    puts (usage);
+			    
 		}
 		return 0;
 	}
@@ -143,7 +148,11 @@
 			}
 			putc ('\n');
 #else	/* no long help available */
+# ifdef CONFIG_PEPPERCON
+			if (cmdtp->usage && (gd->devel_mode || cmdtp->user_allowed))
+# else
 			if (cmdtp->usage)
+# endif
 				puts (cmdtp->usage);
 #endif	/* CFG_LONGHELP */
 		} else {
@@ -217,3 +226,11 @@
 
 	return NULL;	/* not found or ambiguous command */
 }
+
+#ifdef CONFIG_PEPPERCON
+void command_enable_user(const char *cmd)
+{
+	cmd_tbl_t* cmdtp = find_cmd(cmd);
+	if (cmdtp) cmdtp->user_allowed = 1;    
+}
+#endif
Index: common/env_common.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/common/env_common.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- common/env_common.c	3 Feb 2005 09:43:15 -0000	1.1.333.1
+++ common/env_common.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -208,6 +208,14 @@
 #endif
 
 #ifdef ENV_IS_EMBEDDED
+
+#ifdef CONFIG_PEPPERCON
+	/*
+	 * Environment is in separate section -> relocate it
+	 */
+	memcpy((void *)((ulong)env_ptr + gd->reloc_off), env_ptr, CFG_ENV_SIZE);
+#endif /* CONFIG_PEPPERCON */
+
 	/*
 	 * The environment buffer is embedded with the text segment,
 	 * just relocate the environment pointer
Index: common/environment.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/common/environment.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- common/environment.c	3 Feb 2005 09:43:15 -0000	1.1.333.1
+++ common/environment.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -50,6 +50,7 @@
      defined(CONFIG_FADS)	|| \
      defined(CONFIG_HYMOD)	|| \
      defined(CONFIG_ICU862)	|| \
+     defined(CONFIG_PEPPERCON)	|| \
      defined(CONFIG_R360MPI)	|| \
      defined(CONFIG_TQM8xxL)	|| \
      defined(CONFIG_RRVISION)	|| \
@@ -197,6 +198,6 @@
 /*
  * Add in absolutes.
  */
-GEN_ABS(env_offset, CFG_ENV_OFFSET);
+GEN_ABS(env_offset, CFG_ENV_ADDR);
 
 #endif /* ENV_IS_EMBEDDED */
Index: common/main.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/common/main.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- common/main.c	3 Feb 2005 09:43:15 -0000	1.1.333.1
+++ common/main.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -219,6 +219,10 @@
 static __inline__ int abortboot(int bootdelay)
 {
 	int abort = 0;
+#ifdef CONFIG_PEPPERCON
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+	char ch;
+#endif
 
 #ifdef CONFIG_SILENT_CONSOLE
 	{
@@ -235,7 +239,11 @@
 #ifdef CONFIG_MENUPROMPT
 	printf(CONFIG_MENUPROMPT, bootdelay);
 #else
+# ifdef CONFIG_PEPPERCON
+	printf("Press ESC to stop autoboot: %2d ", bootdelay);
+# else
 	printf("Hit any key to stop autoboot: %2d ", bootdelay);
+# endif
 #endif
 
 #if defined CONFIG_ZERO_BOOTDELAY_CHECK
@@ -245,12 +253,22 @@
 	 */
 	if (bootdelay >= 0) {
 		if (tstc()) {	/* we got a key press	*/
+#ifdef CONFIG_PEPPERCON
+		        ch = getc();    /* get the incoming char */
+			if (ch == 0x1b) {
+			    abort  = 1;    /* don't auto boot */
+			    gd->serial_debug = 1;
+			    gd->bd->bi_debug_mode = 1;
+			    break;
+			}
+#else /* !CONFIG_PEPPERCON */
 			(void) getc();  /* consume input	*/
 			printf ("\b\b\b 0");
 			abort = 1; 	/* don't auto boot	*/
+#endif /* !CONFIG_PEPPERCON */
 		}
 	}
-#endif
+#endif /* CONFIG_ZERO_BOOTDELAY_CHECK */
 
 	while ((bootdelay > 0) && (!abort)) {
 		int i;
@@ -259,6 +277,16 @@
 		/* delay 100 * 10ms */
 		for (i=0; !abort && i<100; ++i) {
 			if (tstc()) {	/* we got a key press	*/
+#ifdef CONFIG_PEPPERCON
+			        ch = getc();    /* get the incoming char */
+				if (ch == 0x1b) {
+				    abort  = 1;    /* don't auto boot */
+				    bootdelay = 0; /* no more delay   */ 
+				    gd->serial_debug = 1;
+				    gd->bd->bi_debug_mode = 1;
+				    break;
+				}
+#else /* !CONFIG_PEPPERCON */
 				abort  = 1;	/* don't auto boot	*/
 				bootdelay = 0;	/* no more delay	*/
 # ifdef CONFIG_MENUKEY
@@ -267,6 +295,7 @@
 				(void) getc();  /* consume input	*/
 # endif
 				break;
+#endif /* !CONFIG_PEPPERCON */
 			}
 			udelay (10000);
 		}
@@ -412,7 +441,11 @@
 # endif
 
 # ifndef CFG_HUSH_PARSER
+#  ifdef CONFIG_PEPPERCON
+		run_command (s, 0, 0);
+#  else
 		run_command (s, 0);
+#  endif
 # else
 		parse_string_outer(s, FLAG_PARSE_SEMICOLON |
 				    FLAG_EXIT_FROM_LOOP);
@@ -428,7 +461,11 @@
 	    s = getenv("menucmd");
 	    if (s) {
 # ifndef CFG_HUSH_PARSER
-		run_command (s, bd, 0);
+#  ifdef CONFIG_PEPPERCON
+		run_command (s, 0, 0);
+#  else
+		run_command (s, 0);
+#  endif
 # else
 		parse_string_outer(s, FLAG_PARSE_SEMICOLON |
 				    FLAG_EXIT_FROM_LOOP);
@@ -486,7 +523,11 @@
 		if (len == -1)
 			printf ("<INTERRUPT>\n");
 		else
+#ifdef CONFIG_PEPPERCON
+			rc = run_command (lastcommand, flag, 1);
+#else
 			rc = run_command (lastcommand, flag);
+#endif
 
 		if (rc <= 0) {
 			/* invalid command or not repeatable, forget it */
@@ -574,6 +615,12 @@
 			puts ("\r\n");
 			return (p - console_buffer);
 
+#ifdef CONFIG_PEPPERCON
+		case 0x1B:
+		        /* do nothing on escape */
+		        break;
+#endif /* CONFIG_PEPPERCON */
+
 		case 0x03:				/* ^C - break		*/
 			console_buffer[0] = '\0';	/* discard input */
 			return (-1);
@@ -827,8 +874,15 @@
  * creates or modifies environment variables (like "bootp" does).
  */
 
+#ifdef CONFIG_PEPPERCON
+int run_command (const char *cmd, int flag, int interactive)
+#else
 int run_command (const char *cmd, int flag)
+#endif
 {
+#ifdef CONFIG_PEPPERCON
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+#endif 
 	cmd_tbl_t *cmdtp;
 	char cmdbuf[CFG_CBSIZE];	/* working copy of cmd		*/
 	char *token;			/* start of token in cmdbuf	*/
@@ -913,6 +967,9 @@
 
 		/* found - check max args */
 		if (argc > cmdtp->maxargs) {
+#ifdef CONFIG_PEPPERCON
+		    if (!interactive || gd->devel_mode || cmdtp->user_allowed)
+#endif
 			printf ("Usage:\n%s\n", cmdtp->usage);
 			rc = -1;
 			continue;
@@ -935,9 +992,20 @@
 #endif	/* CFG_CMD_BOOTD */
 
 		/* OK - call function to do the command */
+#ifdef CONFIG_PEPPERCON
+		if (!interactive || gd->devel_mode || cmdtp->user_allowed) {
+		    if ((cmdtp->cmd) (cmdtp, flag, argc, argv) != 0) {
+			rc = -1;
+		    }
+		} else {
+		    printf ("Unknown command '%s' - try 'help'\n", argv[0]);
+		    return -1;
+		}
+#else /* !CONFIG_PEPPERCON */
 		if ((cmdtp->cmd) (cmdtp, flag, argc, argv) != 0) {
 			rc = -1;
 		}
+#endif /* !CONFIG_PEPPERCON */
 
 		repeatable &= cmdtp->repeatable;
 
@@ -969,7 +1037,11 @@
 			return 1;
 		}
 #ifndef CFG_HUSH_PARSER
+# ifdef CONFIG_PEPPERCON
+		if (run_command (arg, flag, 0) == -1)
+# else
 		if (run_command (arg, flag) == -1)
+# endif
 			return 1;
 #else
 		if (parse_string_outer(arg,
Index: common/miiphyutil.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/common/miiphyutil.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- common/miiphyutil.c	3 Feb 2005 09:43:15 -0000	1.1.333.1
+++ common/miiphyutil.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -47,19 +47,15 @@
 		 unsigned char *model, unsigned char *rev)
 {
 	unsigned int reg = 0;
+	unsigned short tmp;
 
-	/*
-	 * Trick: we are reading two 16 registers into a 32 bit variable
-	 * so we do a 16 read into the high order bits of the variable (big
-	 * endian, you know), shift it down 16 bits, and the read the rest.
-	 */
-	if (miiphy_read (addr, PHY_PHYIDR2, (unsigned short *) &reg) != 0) {
+	if (miiphy_read (addr, PHY_PHYIDR2, &tmp) != 0) {
 #ifdef DEBUG
 		printf ("PHY ID register 2 read failed\n");
 #endif
 		return (-1);
 	}
-	reg >>= 16;
+	reg = tmp;
 
 #ifdef DEBUG
 	printf ("PHY_PHYIDR2 @ 0x%x = 0x%04x\n", addr, reg);
@@ -69,12 +65,13 @@
 		return (-1);
 	}
 
-	if (miiphy_read (addr, PHY_PHYIDR1, (unsigned short *) &reg) != 0) {
+	if (miiphy_read (addr, PHY_PHYIDR1, &tmp) != 0) {
 #ifdef DEBUG
 		printf ("PHY ID register 1 read failed\n");
 #endif
 		return (-1);
 	}
+	reg |= tmp << 16;
 #ifdef DEBUG
 	printf ("PHY_PHYIDR[1,2] @ 0x%x = 0x%08x\n", addr, reg);
 #endif
Index: cpu/ppc4xx/405gp_enet.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/405gp_enet.c,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- cpu/ppc4xx/405gp_enet.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/405gp_enet.c	6 Apr 2005 12:44:07 -0000	1.3
@@ -159,7 +159,7 @@
 static int tx_u_index = 0;		/* Transmit User Queue Index */
 static int tx_run[NUM_TX_BUFF];	/* Transmit Running Queue */
 
-#undef INFO_405_ENET 1
+#undef INFO_405_ENET
 #ifdef INFO_405_ENET
 static int packetSent = 0;
 static int packetReceived = 0;
@@ -173,6 +173,13 @@
 static int is_receiving = 0;	/* sync with eth interrupt */
 static int print_speed = 1;	/* print speed message upon start */
 
+static int emac_num = 0;
+#ifdef CONFIG_PEPPERCON
+static unsigned long emac_base = EMAC0_BASE;
+#else
+static unsigned long emac_base = EMAC_BASE;
+#endif
+
 /*-----------------------------------------------------------------------------+
  * Prototypes and externals.
  *-----------------------------------------------------------------------------*/
@@ -195,7 +202,8 @@
 	};
 
 	/* EMAC RESET */
-	out32 (EMAC_M0, EMAC_M0_SRST);
+	out32 (EMAC0_M0, EMAC_M0_SRST);
+	out32 (EMAC1_M0, EMAC_M0_SRST);
 
 	print_speed = 1;		/* print speed message again next time */
 }
@@ -204,6 +212,9 @@
 static int ppc_4xx_eth_init (struct eth_device *dev, bd_t * bis)
 {
 	int i;
+	unsigned char phy_1_available = 0;
+	unsigned char phy_0_available = 0;
+	unsigned char phy_addr = 1;
 	unsigned long reg;
 	unsigned long msr;
 	unsigned long speed;
@@ -256,12 +267,40 @@
 #endif /* CONFIG_440 */
 
 	/* EMAC RESET */
-	out32 (EMAC_M0, EMAC_M0_SRST);
+	out32 (EMAC0_M0, EMAC_M0_SRST);
+	out32 (EMAC1_M0, EMAC_M0_SRST);
 
 	/* wait for PHY to complete auto negotiation */
 	reg_short = 0;
 #ifndef CONFIG_CS8952_PHY
-	miiphy_read (CONFIG_PHY_ADDR, PHY_BMSR, &reg_short);
+
+#if defined(CONFIG_PEPPERCON)
+	if (miiphy_read (1, PHY_BMSR, &reg_short) == 0 && reg_short != 0xffff) {
+	    phy_1_available = 1;
+	}
+
+	if (miiphy_read (0, PHY_BMSR, &reg_short) == 0 && reg_short != 0xffff) {
+	    phy_0_available = 1;
+	}
+
+	if (phy_1_available && phy_0_available) {
+	    phy_addr = CONFIG_PREF_PHY_ADDR;
+	    printf ("Two PHYs found - use PHY on %s interface.\n", CONFIG_PREF_PHY_ADDR ? "first" : "second");
+	} else if (phy_1_available) {
+	    phy_addr = 1;
+	    puts ("PHY on first interface found.\n");
+	} else if (phy_0_available) {
+	    phy_addr = 0;
+	    puts ("PHY on second interface found.\n");
+	} else {
+	    puts ("No PHY found!\n");
+	}
+	emac_num = phy_addr > 0 ? 0 : 1;
+	emac_base = emac_num ? EMAC1_BASE : EMAC0_BASE;
+#else
+	phy_addr = CONFIG_PHY_ADDR
+	miiphy_read (phy_addr, PHY_BMSR, &reg_short);
+#endif
 
 	/*
 	 * Wait if PHY is able of autonegotiation and autonegotiation is not complete
@@ -279,23 +318,42 @@
 				break;
 			}
 
+#if defined(CONFIG_PEPPERCON) && defined(PP_FEAT_USBPOWERED)
+			if ((i % 100) == 0) {
+			    toggle_led_state();
+			}
+#endif
+								
 			if ((i++ % 1000) == 0)
 				putc ('.');
 			udelay (1000);	/* 1 ms */
-			miiphy_read (CONFIG_PHY_ADDR, PHY_BMSR, &reg_short);
+			miiphy_read (phy_addr, PHY_BMSR, &reg_short);
 		}
 		puts (" done\n");
 		udelay (500000);	/* another 500 ms (results in faster booting) */
 	}
 #endif
-	speed = miiphy_speed (CONFIG_PHY_ADDR);
-	duplex = miiphy_duplex (CONFIG_PHY_ADDR);
+	speed = miiphy_speed (phy_addr);
+	duplex = miiphy_duplex (phy_addr);
 	if (print_speed) {
 		print_speed = 0;
 		printf ("ENET Speed is %d Mbps - %s duplex connection\n",
 			(int) speed, (duplex == HALF) ? "HALF" : "FULL");
 	}
 
+#ifdef CONFIG_PEPPERCON
+	/* clear the CRS Select bit - this solves problems with 10BaseT */
+	{
+		unsigned short data;
+		miiphy_read(phy_addr, 0x10, &data);
+		data &= ~0x80DD; // clear CRS Select and reserved bits
+		miiphy_write(phy_addr, 0x10, data);
+	}
+
+	/* set LED configuration */
+	miiphy_write(phy_addr, 0x14, PP_(PHY_LED_CFG_VALUE, PP_HWID));
+#endif
+
 	/* set the Mal configuration reg */
 #if defined(CONFIG_440)
 	/* Errata 1.12: MAL_1 -- Disable MAL bursting */
@@ -383,20 +441,37 @@
 
 	out32 (EMAC_IAL, reg);
 
-	/* setup MAL tx & rx channel pointers */
-	mtdcr (maltxctp0r, tx);
-	mtdcr (malrxctp0r, rx);
-
-	/* Reset transmit and receive channels */
-	mtdcr (malrxcarr, 0x80000000);	/* 2 channels */
-	mtdcr (maltxcarr, 0x80000000);	/* 2 channels */
-
-	/* Enable MAL transmit and receive channels */
-	mtdcr (maltxcasr, 0x80000000);	/* 1 channel */
-	mtdcr (malrxcasr, 0x80000000);	/* 1 channel */
+	if (emac_num == 1) {
+	    /* setup MAL tx & rx channel pointers */
+	    mtdcr (maltxctp0r_1, tx);
+	    mtdcr (malrxctp0r_1, rx);
+
+	    /* Reset transmit and receive channels */
+	    mtdcr (malrxcarr, 0x40000000);	/* 2 channels */
+	    mtdcr (maltxcarr, 0x20000000);	/* 2 channels */
+
+	    /* Enable MAL transmit and receive channels */
+	    mtdcr (maltxcasr, 0x20000000);	/* 1 channel */
+	    mtdcr (malrxcasr, 0x40000000);	/* 1 channel */
 
-	/* set RX buffer size */
-	mtdcr (malrcbs0, ENET_MAX_MTU_ALIGNED / 16);
+	    /* set RX buffer size */
+	    mtdcr (malrcbs0_1, ENET_MAX_MTU_ALIGNED / 16);
+	} else {
+	    /* setup MAL tx & rx channel pointers */
+	    mtdcr (maltxctp0r_0, tx);
+	    mtdcr (malrxctp0r_0, rx);
+
+	    /* Reset transmit and receive channels */
+	    mtdcr (malrxcarr, 0x80000000);	/* 2 channels */
+	    mtdcr (maltxcarr, 0x80000000);	/* 2 channels */
+
+	    /* Enable MAL transmit and receive channels */
+	    mtdcr (maltxcasr, 0x80000000);	/* 1 channel */
+	    mtdcr (malrxcasr, 0x80000000);	/* 1 channel */
+
+	    /* set RX buffer size */
+	    mtdcr (malrcbs0_0, ENET_MAX_MTU_ALIGNED / 16);
+	}
 
 	/* set transmit enable & receive enable */
 	out32 (EMAC_M0, EMAC_M0_TXE | EMAC_M0_RXE);
@@ -434,7 +509,7 @@
 #endif /* CONFIG_440 */
 
 	/* Frame gap set */
-	out32 (EMAC_I_FRAME_GAP_REG, 0x00000008);
+	out32 (EMAC_I_FRAME_GAP_REG, 0x00000004);
 
 	if (first_init == 0) {
 		/*
@@ -675,7 +750,7 @@
 		/* check for EOB on valid channels            */
 		if ((my_uicmsr & UIC_MAL_RXEOB) != 0) {
 			mal_rx_eob = mfdcr (malrxeobisr);
-			if ((mal_rx_eob & 0x80000000) != 0) {	/* call emac routine for channel 0 */
+			if ((mal_rx_eob & (emac_num == 1 ? 0x40000000 : 0x80000000)) != 0) {	/* call emac routine for channel 0 */
 				/* clear EOB
 				   mtdcr(malrxeobisr, mal_rx_eob); */
 				enet_rcv (emac_isr);
@@ -743,7 +818,7 @@
 	int loop_count = 0;
 
 	rx_eob_isr = mfdcr (malrxeobisr);
-	if ((0x80000000 >> (EMAC_RXCHL - 1)) & rx_eob_isr) {
+	if (((emac_num == 1 ? 0x40000000 : 0x80000000) >> (EMAC_RXCHL - 1)) & rx_eob_isr) {
 		/* clear EOB */
 		mtdcr (malrxeobisr, rx_eob_isr);
 
Index: cpu/ppc4xx/405gp_pci.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/405gp_pci.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- cpu/ppc4xx/405gp_pci.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/405gp_pci.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -92,7 +92,7 @@
 
 	int i, reg_num = 0;
 	bd_t *bd = gd->bd;
-
+	unsigned short data16;
 	unsigned short temp_short;
 	unsigned long ptmpcila[2] = {CFG_PCI_PTM1PCI, CFG_PCI_PTM2PCI};
 #if defined(CONFIG_CPCI405)
@@ -102,7 +102,20 @@
 	unsigned long ptmla[2]    = {CFG_PCI_PTM1LA, CFG_PCI_PTM2LA};
 	unsigned long ptmms[2]    = {CFG_PCI_PTM1MS, CFG_PCI_PTM2MS};
 #endif
-#if defined(CONFIG_PIP405) || defined (CONFIG_MIP405)
+#if defined(CONFIG_PEPPERCON)
+	unsigned long pmmla[3]    = {
+		CFG_PCI_PMM0LA, CFG_PCI_PMM1LA, CFG_PCI_PMM2LA
+	};
+	unsigned long pmmma[3]    = {
+		CFG_PCI_PMM0MA, CFG_PCI_PMM1MA, CFG_PCI_PMM2MA
+	};
+	unsigned long pmmpcila[3] = {
+		CFG_PCI_PMM0PCILA, CFG_PCI_PMM1PCILA, CFG_PCI_PMM2PCILA
+	};
+	unsigned long pmmpciha[3] = {
+		CFG_PCI_PMM0PCIHA, CFG_PCI_PMM1PCIHA, CFG_PCI_PMM2PCIHA
+	};
+#elif defined(CONFIG_PIP405) || defined (CONFIG_MIP405)
 	unsigned long pmmla[3]    = {0x80000000, 0xA0000000, 0};
 	unsigned long pmmma[3]    = {0xE0000001, 0xE0000001, 0};
 	unsigned long pmmpcila[3] = {0x80000000, 0x00000000, 0};
@@ -120,6 +133,9 @@
 	hose->first_busno = 0;
 	hose->last_busno = 0xff;
 
+#ifdef CONFIG_PEPPERCON
+	reg_num = 0;
+#else
 	/* ISA/PCI I/O space */
 	pci_set_region(hose->regions + reg_num++,
 		       MIN_PCI_PCI_IOADDR,
@@ -135,6 +151,7 @@
 		       PCI_REGION_IO);
 
 	reg_num = 2;
+#endif
 
 	/* Memory spaces */
 	for (i=0; i<2; i++)
@@ -170,6 +187,18 @@
 
 	pci_register_hose(hose);
 
+#ifdef CONFIG_PEPPERCON
+	/* this resets the PCI bus, which is necessary for the WLAN mini pci card,
+	   which didn't worked after rebooting */
+	pci_read_config_word(PCIDEVID_405GP, 0x60, &data16);
+	pci_write_config_word(PCIDEVID_405GP, 0x60, data16 | 0x1000);
+	
+	udelay(1000); /* is PCI spec 2.1: 4.2.3.2 applicable here? */
+	
+	pci_read_config_word(PCIDEVID_405GP, 0x60, &data16);
+	pci_write_config_word(PCIDEVID_405GP, 0x60, data16 & ~0x1000);
+#endif
+	
 	/*--------------------------------------------------------------------------+
 	 * 405GP PCI Master configuration.
 	 * Map one 512 MB range of PLB/processor addresses to PCI memory space.
@@ -368,12 +397,13 @@
 	{CFG_PCI_SUBSYS_VENDORID, PCI_ANY_ID, PCI_CLASS_BRIDGE_HOST,
 	 PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID, pci_405gp_setup_bridge},
 #endif
+#ifndef CONFIG_PEPPERCON
 	{PCI_ANY_ID, PCI_ANY_ID, PCI_CLASS_DISPLAY_VGA,
 	 PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID, pci_405gp_setup_vga},
 
 	{PCI_ANY_ID, PCI_ANY_ID, PCI_CLASS_NOT_DEFINED_VGA,
 	 PCI_ANY_ID, PCI_ANY_ID, PCI_ANY_ID, pci_405gp_setup_vga},
-
+#endif
 	{ }
 };
 
Index: cpu/ppc4xx/cpu_init.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/cpu_init.c,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- cpu/ppc4xx/cpu_init.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/cpu_init.c	6 Apr 2005 12:44:07 -0000	1.3
@@ -184,6 +184,10 @@
 	mtebc(pb7cr, CFG_EBC_PB7CR);
 #endif
 
+#if (defined(CFG_EBC_EPCR))
+	mtebc(epcr, CFG_EBC_EPCR);
+#endif
+     
 #if defined(CONFIG_WATCHDOG)
 	unsigned long val;
 
@@ -238,7 +242,8 @@
 	reg |= bd->bi_enetaddr[0];           /* set high address */
 	reg = reg << 8;
 	reg |= bd->bi_enetaddr[1];
-	out32 (EMAC_IAH, reg);
+	out32 (EMAC0_IAH, reg);
+	out32 (EMAC1_IAH, reg);
 
 	reg = 0x00000000;
 	reg |= bd->bi_enetaddr[2];           /* set low address  */
@@ -248,7 +253,8 @@
 	reg |= bd->bi_enetaddr[4];
 	reg = reg << 8;
 	reg |= bd->bi_enetaddr[5];
-	out32 (EMAC_IAL, reg);
+	out32 (EMAC0_IAL, reg);
+	out32 (EMAC1_IAL, reg);
 
 #if defined(CONFIG_405GP)
 	/*
Index: cpu/ppc4xx/interrupts.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/interrupts.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- cpu/ppc4xx/interrupts.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/interrupts.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -375,8 +375,15 @@
 #if 0
 	printf ("*** Timer Interrupt *** ");
 #endif
+
 	timestamp++;
 
+#if defined(CONFIG_PEPPERCON) && defined(PP_FEAT_USBPOWERED)
+	if ((timestamp % 100) == 0) {
+	    toggle_led_state();
+	}
+#endif
+	
 #if defined(CONFIG_WATCHDOG)
 	if ((timestamp % 1000) == 0)
 		reset_4xx_watchdog();
Index: cpu/ppc4xx/miiphy.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/miiphy.c,v
retrieving revision 1.1.333.1
retrieving revision 1.3
diff -u -r1.1.333.1 -r1.3
--- cpu/ppc4xx/miiphy.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/miiphy.c	6 Apr 2005 12:44:07 -0000	1.3
@@ -107,9 +107,6 @@
 	sta_reg = sta_reg | (addr << 5);	/* Phy address */
 
 	out32 (EMAC_STACR, sta_reg);
-#if 0	/* test-only */
-	printf ("a2: write: EMAC_STACR=0x%0x\n", sta_reg);	/* test-only */
-#endif
 
 	sta_reg = in32 (EMAC_STACR);
 	i = 0;
@@ -123,13 +120,15 @@
 		sta_reg = in32 (EMAC_STACR);
 	}
 	if ((sta_reg & EMAC_STACR_PHYE) != 0) {
+#if 0
 		printf ("read err 3\n");
 		printf ("a2: read: EMAC_STACR=0x%0lx, i=%d\n",
 			sta_reg, (int) i);	/* test-only */
+#endif
 		return -1;
 	}
 
-	*value = *(short *) (&sta_reg);
+	memcpy (value, &sta_reg, 2);   /* read data */
 	return 0;
 
 
Index: cpu/ppc4xx/serial.c
===================================================================
RCS file: /srv/CVS/pplinux/u-boot/cpu/ppc4xx/serial.c,v
retrieving revision 1.1.333.1
retrieving revision 1.2
diff -u -r1.1.333.1 -r1.2
--- cpu/ppc4xx/serial.c	3 Feb 2005 09:43:12 -0000	1.1.333.1
+++ cpu/ppc4xx/serial.c	3 Feb 2005 10:35:41 -0000	1.2
@@ -543,7 +543,23 @@
 void serial_putc (const char c)
 {
 	int i;
+#ifdef CONFIG_PEPPERCON
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
 
+	/* only if we have a e-RIC debug cable attached and debugging is enabled */
+	if (gd->serial_debug) {
+		if (c == '\n')
+			serial_putc ('\r');
+
+		/* check THRE bit, wait for transmiter available */
+		for (i = 1; i < 3500; i++) {
+		    if ((in8 (ACTING_UART0_BASE + UART_LSR) & 0x20) == 0x20)
+			break;
+		    udelay (100);
+		}
+		out8 (ACTING_UART0_BASE + UART_THR, c);	/* put character out */
+	}
+#else /* !CONFIG_PEPPERCON */
 	if (c == '\n')
 		serial_putc ('\r');
 
@@ -554,6 +570,7 @@
 		udelay (100);
 	}
 	out8 (ACTING_UART0_BASE + UART_THR, c);	/* put character out */
+#endif /* !CONFIG_PEPPERCON */
 }
 
 
@@ -569,50 +586,110 @@
 {
 	unsigned char status = 0;
 
-	while (1) {
+#ifdef CONFIG_PEPPERCON
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+
+	/* only if we have a e-RIC debug cable attached */
+	if (gd->debug_cable_present) {
+#endif /* CONFIG_PEPPERCON */
+		while (1) {
 #if defined(CONFIG_HW_WATCHDOG)
-		WATCHDOG_RESET ();	/* Reset HW Watchdog, if needed */
+			WATCHDOG_RESET ();	/* Reset HW Watchdog, if needed */
 #endif	/* CONFIG_HW_WATCHDOG */
+			status = in8 (ACTING_UART0_BASE + UART_LSR);
+			if ((status & asyncLSRDataReady1) != 0x0) {
+				break;
+			}
+			if ((status & ( asyncLSRFramingError1 |
+					asyncLSROverrunError1 |
+					asyncLSRParityError1  |
+					asyncLSRBreakInterrupt1 )) != 0) {
+				out8 (ACTING_UART0_BASE + UART_LSR,
+				      asyncLSRFramingError1 |
+				      asyncLSROverrunError1 |
+				      asyncLSRParityError1  |
+				      asyncLSRBreakInterrupt1);
+			}
+		}
+		return (0x000000ff & (int) in8 (ACTING_UART0_BASE));
+#ifdef CONFIG_PEPPERCON
+	}
+	return 0;
+#endif /* CONFIG_PEPPERCON */
+}
+
+
+int serial_tstc ()
+{
+	unsigned char status;
+#ifdef CONFIG_PEPPERCON
+	gd_t * gd = (gd_t *) (CFG_INIT_RAM_ADDR + CFG_GBL_DATA_OFFSET);
+
+	/* only if we have a e-RIC debug cable attached */
+	if (gd->debug_cable_present) {
+#endif /* CONFIG_PEPPERCON */
 		status = in8 (ACTING_UART0_BASE + UART_LSR);
 		if ((status & asyncLSRDataReady1) != 0x0) {
-			break;
+			return (1);
 		}
 		if ((status & ( asyncLSRFramingError1 |
 				asyncLSROverrunError1 |
 				asyncLSRParityError1  |
 				asyncLSRBreakInterrupt1 )) != 0) {
-			out8 (ACTING_UART0_BASE + UART_LSR,
-			      asyncLSRFramingError1 |
-			      asyncLSROverrunError1 |
-			      asyncLSRParityError1  |
-			      asyncLSRBreakInterrupt1);
+		    out8 (ACTING_UART0_BASE + UART_LSR,
+			  asyncLSRFramingError1 |
+			  asyncLSROverrunError1 |
+			  asyncLSRParityError1  |
+			  asyncLSRBreakInterrupt1);
 		}
+#ifdef CONFIG_PEPPERCON
 	}
-	return (0x000000ff & (int) in8 (ACTING_UART0_BASE));
+#endif /* CONFIG_PEPPERCON */
+	return 0;
 }
 
-
-int serial_tstc ()
+#ifdef CONFIG_PEPPERCON
+int serial_debug_cable_present(void)
 {
-	unsigned char status;
-
-	status = in8 (ACTING_UART0_BASE + UART_LSR);
-	if ((status & asyncLSRDataReady1) != 0x0) {
-		return (1);
-	}
-	if ((status & ( asyncLSRFramingError1 |
-			asyncLSROverrunError1 |
-			asyncLSRParityError1  |
-			asyncLSRBreakInterrupt1 )) != 0) {
-		out8 (ACTING_UART0_BASE + UART_LSR,
-		      asyncLSRFramingError1 |
-		      asyncLSROverrunError1 |
-		      asyncLSRParityError1  |
-		      asyncLSRBreakInterrupt1);
+#define TOGGLE_COUNT 20
+	int dcd_toggle_count = 0;
+	int cts_toggle_count = 0;
+	u8 mcr = 0;
+	u8 mcr_save = 0;
+	u8 msr;
+	int i;
+
+	int re_enable = disable_interrupts();
+
+	mcr_save = in8(ACTING_UART0_BASE + UART_MCR);
+	out8(ACTING_UART0_BASE + UART_MCR, mcr);  /* set DTR & RTS to 0 */
+	msr = in8(ACTING_UART0_BASE + UART_MSR);
+	/*
+	 * NOTE: Settimg DTR and RTS at the same time will not give the expected
+	 *       result. So we test it sequentially.
+	 */
+	for (i = 0; i < TOGGLE_COUNT; i++) { /* check DTR and DCD connection */
+		mcr = (~mcr) & 0x1;
+		out8(ACTING_UART0_BASE + UART_MCR, mcr);
+		udelay(10000);
+		msr = in8(ACTING_UART0_BASE + UART_MSR);
+		dcd_toggle_count += (msr & 0x8) >> 3;
+	}
+	for (i = 0; i < TOGGLE_COUNT; i++) { /* check RTS and CTS connection */
+		mcr = (~mcr) & 0x2;
+		out8(ACTING_UART0_BASE + UART_MCR, mcr);
+		udelay(10000);
+		msr = in8(ACTING_UART0_BASE + UART_MSR);
+		cts_toggle_count += msr & 0x1;
 	}
-	return 0;
-}
+	out8(ACTING_UART0_BASE + UART_MCR, mcr_save);  /* restore UART MCR register */
+
+	if (re_enable) enable_interrupts();
 
+	return (dcd_toggle_count == TOGGLE_COUNT ||
+		cts_toggle_count == TOGGLE_COUNT);
+}
+#endif /* CONFIG_PEPPERCON */
 
 #if CONFIG_SERIAL_SOFTWARE_FIFO
 
